//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  PaleGreen
#property  indicator_color2  Red
#property  indicator_level1  0
#property  indicator_levelcolor Gold
//---- indicator parameters
extern int Fast=6;
extern int Slow=8;
extern int PriceFast=0;
extern int PriceSlow=1;
extern int ModeFast=1;
extern int ModeSlow=2;
extern int SignalSMA=9;
extern bool Signal = true;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
//double     PriceBuffer[];
int pre_signal = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
  // SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(0,SignalSMA);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits);
//---- indicator buffers mapping
  // SetIndexBuffer(0,PriceBuffer);
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+Fast+","+Slow+","+SignalSMA+")");
 //  SetIndexLabel(0,"Price");
 //  SetIndexLabel(1,"MACD");
  // SetIndexLabel(2,"Signal");
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,Fast,0,ModeFast,PriceFast,i)-iMA(NULL,0,Slow,0,ModeSlow,PriceSlow,i);
//---- signal line counted 
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);

  //--------------------------------------------------------------------+        
      if(Signal)
        {
             if(pre_signal <= 0 && MacdBuffer[1]<0 && MacdBuffer[0]>0) 
               { 
                // Alert("MACD  BUY! ",Symbol()," ", Period());
                PlaySound("news.wav");
                 pre_signal =  1; 
               }
             if(pre_signal >= 0 && MacdBuffer[1]>0 && MacdBuffer[0]<0) 
               { 
                // Alert("MACD  SELL! ",Symbol()," ", Period());
                PlaySound("timeout.wav");
                 pre_signal = -1; 
               }               
        }
   return(0);
  }
//+------------------------------------------------------------------+